import { isJSON } from '@procyon/utils';

import { UseFetchTokensParams } from './types';

export const fetchTokens = async ({
	baseUrl,
	tokenEndpoint,
	clientId,
	code,
	grantType,
	redirectUri,
}: UseFetchTokensParams) => {
	try {
		const response = await fetch(`${baseUrl}${tokenEndpoint}`, {
			method: 'post',
			headers: { 'Content-Type': 'application/x-www-form-urlencoded' },
			body: new URLSearchParams({
				code,
				client_id: clientId,
				grant_type: grantType,
				redirect_uri: redirectUri,
			}),
		});
		const data = await response.text().then((text: string) => (isJSON(text) ? JSON.parse(text) : text));
		if (!response.ok) throw response;
		return { data };
	} catch (error) {
		return { error };
	}
};
