import React, { FC, ReactElement } from 'react';
import clsx from 'clsx';

import { SizeEnum } from '@procyon/types/common';

export type TextProps = {
	children?: ReactElement | string;
	className?: string;
	size?: SizeEnum;
};

export const Text: FC<TextProps> = ({ size = SizeEnum.sm, children, className }) => (
		<div
			className={clsx(
				{
					'text-base': size === SizeEnum.sm,
					'text-2xl mb-1': size === SizeEnum.md,
					'text-3xl mb-2': size === SizeEnum.lg,
					'text-4xl mb-3': size === SizeEnum.xl,
				},
				className
			)}>
			{children}
		</div>
	)
